/* See: http://solariz.de/de/google_drive_linux_gdsheet_handler_gdrive.htm 
   for Information, License or whatever :p */

#include <json/json.h>
#include <stdlib.h>
#include <string.h>    // strlen
#include <stdio.h>

char* readFile(char* filename)
{
    FILE* file = fopen(filename,"r");
    if(file == NULL)
    {
        return NULL;
    }

    fseek(file, 0, SEEK_END);
    long int size = ftell(file);
    rewind(file);

    char* content = calloc(size + 1, 1);

    fread(content,1,size,file);

    return content;
}

const char* escapeshellarg(const char* str) {
    char *esc = strdup(str);
    int i = 0;
    int len = strlen(str) + 1;
 
    while( *str ) {
        if( *str == '\'' || *str == '\\' ) {
            esc[i++] = '\\';
            len += 1;
            esc = (char*)realloc(esc, len);
        }
        esc[i++] = *str++;
    }
    esc[i] = 0;
    return esc;
}

int main ( int argc, char *argv[] )
{
    if ( argc != 2 ) /* argc should be 2 for correct execution */
    {
        /* We print argv[0] assuming it is the program name */
        printf( "usage: %s <filename>", argv[0] );
    }
    else 
    {
        // argv[1] is a filename to open, let's try:
        FILE *file = fopen( argv[1], "r" );

        /* fopen returns 0, the NULL pointer, on failure */
        if ( file == 0 )
        {
            printf( "ERROR: Could not open file!\n" );
        }
        else 
        {
            fclose( file );
            /* read */
            char * raw = readFile(argv[1]);
            json_object * jobj = json_tokener_parse(raw);
            const char * url = json_object_get_string(json_object_object_get(jobj, "url"));
            /* prevent exploding buffer */
            if(strlen(url) > 230) {
            	printf("URL String to Long! Maximum 230 Chars!\n");
            	exit(0);
            }
            /* only for Google Docs! */
            if(strstr(url, "https://docs.google.com/") != NULL || strstr(url, "https://docs.google.com/") != NULL) {
            	printf("Google docs target found!\n");
			} else {
				printf("URL Seems not a google Docs target, break!\n");
				exit(0);
			}
			/* Escape String */
            const char * str = escapeshellarg(url);
            /* and open Browser (only works in Gnome) */
            const char * cmd = "/usr/bin/gnome-open \"";
			char buffer[256]; // <- danger, only storage for 256 char!
			strncpy(buffer, cmd, sizeof(buffer));
			strncat(buffer, str, sizeof(buffer));
			strncat(buffer, "\"", sizeof(buffer));
			//printf("cmd: %s\n",buffer);
			printf("Opening Browser...\n");
			system(buffer);
			/* Over and out */
			exit(1);
        }
    }
}
